/*───────────────────────────────────────────────────────────────────────────*\
│  Copyright (C) 2014 eBay Software Foundation                                │
│                                                                             │
│hh ,'""`.                                                                    │
│  / _  _ \  Licensed under the Apache License, Version 2.0 (the "License");  │
│  |(@)(@)|  you may not use this file except in compliance with the License. │
│  )  __  (  You may obtain a copy of the License at                          │
│ /,'))((`.\                                                                  │
│(( ((  )) ))    http://www.apache.org/licenses/LICENSE-2.0                   │
│ `\ `)(' /'                                                                  │
│                                                                             │
│   Unless required by applicable law or agreed to in writing, software       │
│   distributed under the License is distributed on an "AS IS" BASIS,         │
│   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  │
│   See the License for the specific language governing permissions and       │
│   limitations under the License.                                            │
\*───────────────────────────────────────────────────────────────────────────*/
'use strict';


function Iterator(items, factory) {
    this._items = items;
    this._factory = factory;
    this._current = 0;
}

Iterator.prototype = {

    get complete() {
        return this._current >= this._items.length;
    },

    next: function () {
        var item;

        if (this.complete) {
            throw new Error('StopIteration');
        }

        item = this._items[this._current];
        this._factory && (item = this._factory.create(item, this._current, this._items));
        this._current += 1;

        return item;
    }

};


module.exports = Iterator;