/*───────────────────────────────────────────────────────────────────────────*\
│  Copyright (C) 2014 eBay Software Foundation                                │
│                                                                             │
│hh ,'""`.                                                                    │
│  / _  _ \  Licensed under the Apache License, Version 2.0 (the "License");  │
│  |(@)(@)|  you may not use this file except in compliance with the License. │
│  )  __  (  You may obtain a copy of the License at                          │
│ /,'))((`.\                                                                  │
│(( ((  )) ))    http://www.apache.org/licenses/LICENSE-2.0                   │
│ `\ `)(' /'                                                                  │
│                                                                             │
│   Unless required by applicable law or agreed to in writing, software       │
│   distributed under the License is distributed on an "AS IS" BASIS,         │
│   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  │
│   See the License for the specific language governing permissions and       │
│   limitations under the License.                                            │
\*───────────────────────────────────────────────────────────────────────────*/
'use strict';

var Os = require('os');
var Util = require('./util');


// XXX: This is NOT built to be used in a clustered scenario just yet.

var OS_STATS = ['hostname', 'loadavg', 'totalmem', 'freemem'];
var data = {
    counters: {}
};



/**
 * The HAPI request handler for serving stats.
 * @param req
 * @param reply
 */
exports.handler = function (req, reply) {
    reply(data);
};


exports.increment = Util.init(data.counters, function (obj, prop) {
    obj[prop] += 1;
});


exports.decrement = Util.maybe(data.counters, function (obj, prop) {
    obj[prop] -= 1;
});



/**
 * Manages aggregating all the relevant info
 */
(function calculate() {
    OS_STATS.reduce(function (data, stat) {
        data[stat] = Os[stat]();
        return data;
    }, data);

    data.memoryUsage = process.memoryUsage();

    setTimeout(calculate, 5000).unref();
})();
